--- pgadmin3/pgadmin/include/frm/frmMain.h	2011-04-12 19:26:25.000000000 +0200
+++ changes/frmMain.h	2011-03-22 09:56:50.000000000 +0100
@@ -146,6 +146,14 @@
 		return pluginsMenu;
 	}
 
+	pgObject *GetCopytObject() {
+		return copytObject;
+	}
+
+	void SetCopytObject(pgObject *obj) {
+		copytObject = obj;
+	}
+
 	wxString GetCurrentNodePath();
 	bool SetCurrentNode(wxTreeItemId node, const wxString &path);
 
@@ -185,6 +193,8 @@
 	pgObject *currentObject;
 	wxControl *currentControl;
 
+	pgObject *copytObject;
+
 	void OnChildFocus(wxChildFocusEvent &event);
 	void OnEraseBackground(wxEraseEvent &event);
 	void OnSize(wxSizeEvent &event);
@@ -335,4 +345,20 @@
 	bool enableButton;
 };
 
+class copyObjectFactory : public contextActionFactory
+{
+public:
+	copyObjectFactory(menuFactoryList *list, wxMenu *mnu, ctlMenuToolbar *toolbar);
+	wxWindow *StartDialog(frmMain *form, pgObject *obj);
+	bool CheckEnable(pgObject *obj);
+};
+
+class pasteObjectFactory : public contextActionFactory
+{
+public:
+	pasteObjectFactory(menuFactoryList *list, wxMenu *mnu, ctlMenuToolbar *toolbar);
+	wxWindow *StartDialog(frmMain *form, pgObject *obj);
+	bool CheckEnable(pgObject *obj);
+};
+
 #endif